/*
  Project: LCD 12864 module ST7920 controller
  Function: Example code for the F() macro. This example requires Arduino 1.0 and above. To setup u8g object for your controller please remove comment
            from one of the following constructor list
            The following list is incomplete. The complete list of supported devices with all constructor calls is here: http://code.google.com/p/u8glib/wiki/device
            or look in examples folder of U8GLIB library.*/
//********************************************************************************
#include "U8glib.h"
//********************************************************************************
//U8GLIB_ST7920_128X64_1X u8g(5, 6, 7, 8, 9, 10, 11, 12, 4, 2, 3);   // 8Bit Com: D0..D7: 5, 6, 7, 8, 9, 10, 11, 12 en=4, di=2,rw=3
//U8GLIB_ST7920_128X64_4X u8g(5, 6, 7, 8, 9, 10, 11, 12, 4, 2, 3);   // 8Bit Com: D0..D7: 5, 6, 7, 8, 9, 10, 11, 12 en=4, di=2,rw=3

U8GLIB_ST7920_128X64_1X u8g(13, 11, 10);  // SPI Com: SCK = en = 13, MOSI = rw = 11, CS = di = 10
//U8GLIB_ST7920_128X64_4X u8g(13, 11, 10);  // SPI Com: SCK = en = 13, MOSI = rw = 11, CS = di = 10

void draw(void) {
  // graphic commands to redraw the complete screen should be placed here  
  
  // assign default font
  u8g.setFont(u8g_font_unifont);
  
  // pointer to strings in flash memory can be stored in a special type
  const __FlashStringHelper *flash_ptr;
  
  // the result of the F() macro can be assigned to this pointer
  flash_ptr = F("Welcome!!!");
  
  // this pointer can be used as argument to the draw procedures
  u8g.drawStr( 0+1, 20+1, flash_ptr);
  u8g.drawStr( 0, 20, flash_ptr);
  
  // of course, the F() macro can be used directly
  u8g.drawStr( 0, 40, F("Acoptex.com 2017"));

}

void setup(void) {
  // flip screen, if required
  // u8g.setRot180();
}

void loop(void) {
  // picture loop
  u8g.firstPage();  
  do {
    draw();
  } while( u8g.nextPage() );
  
  // rebuild the picture after some delay
  delay(500);
}

