/*
  Project: LCD 12864 module ST7920 controller
  Function: "Hello World!" example code scale. This example requires Arduino 1.0 and above. To setup u8g object for your controller please remove comment
            from one of the following constructor list
            The following list is incomplete. The complete list of supported devices with all constructor calls is here: http://code.google.com/p/u8glib/wiki/device
            or look in examples folder of U8GLIB library.*/
  
//********************************************************************************
#include "U8glib.h"
//********************************************************************************
//U8GLIB_ST7920_128X64_1X u8g(5, 6, 7, 8, 9, 10, 11, 12, 4, 2, 3);   // 8Bit Com: D0..D7: 5, 6, 7, 8, 9, 10, 11, 12 en=4, di=2,rw=3
//U8GLIB_ST7920_128X64_4X u8g(5, 6, 7, 8, 9, 10, 11, 12, 4, 2, 3);   // 8Bit Com: D0..D7: 5, 6, 7, 8, 9, 10, 11, 12 en=4, di=2,rw=3

U8GLIB_ST7920_128X64_1X u8g(13, 11, 10);  // SPI Com: SCK = en = 13, MOSI = rw = 11, CS = di = 10
//U8GLIB_ST7920_128X64_4X u8g(13, 11, 10);  // SPI Com: SCK = en = 13, MOSI = rw = 11, CS = di = 10

void draw(void) {
  // graphic commands to redraw the complete screen should be placed here  
  u8g.setFont(u8g_font_unifont);
  u8g.setFontPosTop();
  u8g.drawStr(0, 1, "Hello");
  u8g.drawHLine(0, 1+14, 40);
  u8g.setScale2x2();					// Scale up all draw procedures
  u8g.drawStr(0, 12, "Hello");			// actual display position is (0,24)
  u8g.drawHLine(0, 12+14, 40);		// All other procedures are also affected
  u8g.undoScale();					// IMPORTANT: Switch back to normal mode
}

void setup(void) {
  
  // flip screen, if required
  u8g.setRot180();
  
  // set SPI backup if required
  //u8g.setHardwareBackup(u8g_backup_avr_spi);

  // assign default color value
  if ( u8g.getMode() == U8G_MODE_R3G3B2 ) 
    u8g.setColorIndex(255);     // white
  else if ( u8g.getMode() == U8G_MODE_GRAY2BIT )
    u8g.setColorIndex(3);         // max intensity
  else if ( u8g.getMode() == U8G_MODE_BW )
    u8g.setColorIndex(1);         // pixel on
}

void loop(void) {
  // picture loop
  u8g.firstPage();  
  do {
    draw();
  } while( u8g.nextPage() );
  
  // rebuild the picture after some delay
  delay(500);
}

