 /*
  Project: LCD 12864 module ST7920 controller
  Function: Text rotation example code. This example requires Arduino 1.0 and above. To setup u8g object for your controller please remove comment
            from one of the following constructor list
            The following list is incomplete. The complete list of supported devices with all constructor calls is here: http://code.google.com/p/u8glib/wiki/device
            or look in examples folder of U8GLIB library.*/
  
//********************************************************************************
#include "U8glib.h"
//********************************************************************************
//U8GLIB_ST7920_128X64_1X u8g(5, 6, 7, 8, 9, 10, 11, 12, 4, 2, 3);   // 8Bit Com: D0..D7: 5, 6, 7, 8, 9, 10, 11, 12 en=4, di=2,rw=3
//U8GLIB_ST7920_128X64_4X u8g(5, 6, 7, 8, 9, 10, 11, 12, 4, 2, 3);   // 8Bit Com: D0..D7: 5, 6, 7, 8, 9, 10, 11, 12 en=4, di=2,rw=3

U8GLIB_ST7920_128X64_1X u8g(13, 11, 10);  // SPI Com: SCK = en = 13, MOSI = rw = 11, CS = di = 10
//U8GLIB_ST7920_128X64_4X u8g(13, 11, 10);  // SPI Com: SCK = en = 13, MOSI = rw = 11, CS = di = 10

// graphic commands to redraw the complete screen should be placed here  
void draw(void) {
  u8g_uint_t mx, my;
  
  mx = u8g.getWidth();
  mx >>= 1;
  
  my = u8g.getHeight();
  my >>= 1;
  
  u8g.drawStr( mx, my, "Ag");
  u8g.drawStr90( mx, my, "Ag");
  u8g.drawStr180( mx, my, "Ag");
  u8g.drawStr270( mx, my, "Ag");
}

void setup(void) {
  u8g.setFont(u8g_font_9x18);
}

void change_font_pos(void) {
  static  uint8_t dir = 0;
  static  unsigned long next = 0;

  if ( next < millis() )
  {
    switch(dir) {
      case 0: u8g.setFontPosBottom(); break;
      case 1: u8g.setFontPosBaseline(); break;
      case 2: u8g.setFontPosCenter(); break;
      case 3: u8g.setFontPosTop(); break;
    }
    
    dir++;
    dir &= 3;
    next = millis();
    next += 1000;
  }
}

void loop(void) {
  // change the font position  
  change_font_pos();
  
  // picture loop
  u8g.firstPage();  
  do {
    draw();
  } while( u8g.nextPage() );
  
  // rebuild the picture after some delay
  delay(100);
}

